; #########################################################################

      .386
      .model flat, stdcall
      option casemap :none   ; case sensitive

; #########################################################################

      include \masm32\include\windows.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc

      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib

; #########################################################################

    ;=================
    ; Local prototypes
    ;=================
    DlgProc    PROTO :DWORD,:DWORD,:DWORD,:DWORD
    wsprintfA  PROTO C :DWORD,:VARARG

.data
    dlgname       db "DLG0",0
    hInstance     dd 0
    hProcess      dd 0
    hIcon         dd 0
    b0_handle     dd 0
    b1_handle     dd 0
    c0_handle     dd 0
    szTitle0      db "The MessageBox Title",0
    szMsg0        db "You clicked on the CALC button.",0
    szMsgChk0     db "Checked",0
    szMsgNChk0    db "Not Checked",0

.const
    IDC_BUTTON0   equ    3000
    IDC_BUTTON1   equ    3001
    IDC_TEXT0     equ    3300
    IDC_CHECKBOX0 equ    3300
    EXAMPLE       equ    4001

.code

start:

; #########################################################################

        invoke GetModuleHandle, NULL
        mov    hInstance, eax

        ; -------------------------------------------
        ; Call the dialog box stored in resource file
        ; -------------------------------------------
        invoke DialogBoxParam,hInstance,ADDR dlgname,0,ADDR DlgProc,NULL

        invoke ExitProcess,eax

; #########################################################################

DlgProc proc hWin   :DWORD,
             uMsg   :DWORD,
             wParam :DWORD,
             lParam :DWORD

      .if uMsg == WM_INITDIALOG
         invoke LoadIcon,hInstance,EXAMPLE
         mov hIcon, eax
         invoke SendMessage,hWin,WM_SETICON,1,hIcon

         invoke  GetDlgItem,hWin,IDC_BUTTON0    ; Button0
         mov b0_handle, eax
         invoke  GetDlgItem,hWin,IDC_BUTTON1    ; Button1
         mov b1_handle, eax
         invoke  GetDlgItem,hWin,IDC_CHECKBOX0  ; CheckBox0
         mov c0_handle, eax

      .elseif uMsg==WM_COMMAND
        mov  eax,wParam
        mov  edx,eax
        shr  edx,16
 	  .if dx==BN_CLICKED
		.if eax==IDC_BUTTON0        ; the CALC button clicked now do stuff
               nop
               invoke MessageBox, NULL,addr szMsg0, addr szTitle0, MB_OK

		.elseif eax==IDC_BUTTON1    ; the EXIT button will be an EXIT
		   invoke SendMessage,hWin,WM_CLOSE,NULL,NULL

		.elseif eax==IDC_CHECKBOX0  ; the CheckBox
                invoke  SendMessage, c0_handle, BM_GETCHECK, 0, 0
                .if ( eax != 0 )        ; determine if Checkbox checked
                   invoke MessageBox, NULL,addr szMsgChk0, addr szTitle0, MB_OK
                .else
                   invoke MessageBox, NULL,addr szMsgNChk0, addr szTitle0, MB_OK
                .endif

		.endif
        .endif

      .elseif uMsg == WM_CLOSE
        invoke EndDialog,hWin,0

      .endif

    xor eax, eax
    ret

DlgProc endp

; ########################################################################

end start